<template>
  <v-container>
    <v-row>
      <v-col cols="5">
        <v-btn @click="doAdd">Add New</v-btn>
      </v-col>
      <v-col cols="7">
        <h1>Role</h1>
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="12">
        <v-data-table
            :headers="headers"
            :items="roles"
            :search="search"
            :custom-filter="doSearch"
        >
          <template v-slot:top>
            <v-text-field
                v-model="search"
                label="Search (UPPER CASE ONLY)"
                class="mx-4"
            ></v-text-field>
          </template>
          <template v-slot:[`item.actions`]="{ item }">
            <v-icon small class="mr-2" @click="doEdit(item.id)">mdi-pencil</v-icon>
            <v-icon small @click="doDelete(item)">mdi-delete</v-icon>
          </template>
        </v-data-table>
      </v-col>
    </v-row>
    <RoleForm ref="dlg" />
    <DlgMsg ref="dlgMsg" />
    <Loading ref="loading" :dlg-loading="statusProgress" />
  </v-container>
</template>

<script>
import DlgMsg from "../components/dialog/DlgMsg";
import Loading from "../components/dialog/Loading";

import RoleForm from "../components/RoleForm";
import service from "../service/RoleService";
import {checkError404} from "../utils/util";

export default {
  name: "Role",
  components: {
    RoleForm,
    DlgMsg,
    Loading,
  },
  data: function () {
    return {
      search: '',
      roles: [],
      title: null,
      headers: [
        { text: "ACTION", align: "center", value: "actions", sortable: false },
        { text: "ID.", align: "center", value: "id", sortable: false },
        { text: "NAME", align: "left", value: "name", sortable: true },
        { text: "MENU", align: "left", value: "menus", sortable: true },
        { text: "CREATE DATE", align: "center", value: "create_at", sortable: true },
        { text: "UPDATE DATE", align: "center", value: "update_at", sortable: true },
      ],
      dialogAdd: false,
      statusProgress: false,
    }
  },
  methods: {
    doSearch(value, search) {
      return value != null &&
          search != null &&
          typeof value === 'string' &&
          value.toString().toUpperCase().indexOf(search) !== -1
    },
    doAdd() {
      let title = "Add New Role"
      this.$refs.dlg.doAdd(title, false)
    },
    async doDelete(data) {
      if (!await this.$refs.dlgMsg.confirm(`Apakah Ingin Menghapus Data ROLE ${data.id} - ${data.name}`)) {
        return false;
      }
      this.statusProgress = true
      await service.delete(data.id).then(async res => {
        let {status, message} = res.data
        if (status === 'SUCCESS') {
          await this.doRefresh()
        }
        this.$refs.dlgMsg.doOpenMsg(message)
      }).catch(ex => {
        console.log(ex)
        this.$refs.dlgMsg.doOpenMsg(`ERROR EXCEPTION`)
      })
      this.statusProgress = false
    },
    doEdit(id) {
      let title = "Edit Role"
      this.$refs.dlg.doEdit(id, title, true)
    },
    async doRefresh() {
      this.statusProgress = true
      await service.getAll()
          .then(res => {
            let status = res.data.status
            if (status === 'SUCCESS') {
              this.roles = []
              let roles = res.data.data
              for (let role of roles) {
                let menus = role.menus
                role.menus = []
                for (let menu of menus) {
                  role.menus.push(menu.name)
                }
                this.roles.push(role)
              }
            }
          }).catch(ex => {
            checkError404(ex, this.$refs.dlgMsg)
          })
      this.statusProgress = false
    }
  },
  mounted() {
    this.doRefresh()
  }
}
</script>

<style scoped>

</style>